Bug 477035 - EFI BIOS support in qemu
EFI BIOS support in qemu
Status: CLOSED CANTFIX
Product: Fedora
Classification: Fedora
Component: qemu (Show other bugs)
17
All Linux
low Severity medium
: ---
: ---
Assigned To: Fedora Virtualization Maintainers
Fedora Extras Quality Assurance
:
Depends On: 1112275 1174132 653382 1112257
Blocks:
  Show dependency treegraph
 
Reported: 2008-12-18 14:50 EST by Bill Nottingham
Modified: 2014-12-15 03:50 EST (History)
18 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-05-29 18:34:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Bill Nottingham 2008-12-18 14:50:18 EST
Many newer machines, be they Apple latops and workstations, Dell servers, or even big iron from various vendors, have switched from legacy BIOS implementations to EFI. kvm should offer the same BIOS interface, to allow for the following:

- consistent interface between baremetal and virt on such machines
- easier ability to test our EFI code
- wheee, virt OSX

Version-Release number of selected component (if applicable):

kvm-79
Comment 1 Daniel Berrange 2009-03-11 08:38:58 EDT
Reassigning: The kvm package no longer exists in rawhide/F11, since it is now part of 'qemu'.
Comment 2 Chris Ward 2009-04-06 05:30:28 EDT
~Attention~

This bug appears to pertain to an important F11 feature, EFI, which the Fedora Community will be testing in an upcoming Fedora Test Day. Your participation in the action would be greatly appreciated!

More information:
https://fedoraproject.org/wiki/QA/Test_Days/2009-04-09
https://fedoraproject.org/wiki/Features/EFI
Comment 3 Mark McLoughlin 2009-04-06 09:36:42 EDT
Here's a hg repo for some EFI firmware:

  http://xenbits.xensource.com/ext/efi-vfirmware.hg

I've no idea how useful this currently is in QEMU - I think Tristan Gold posted pre-built images on built from this source before qemu.org. 

(In reply to comment #2)

> This bug appears to pertain to an important F11 feature, EFI, which the Fedora
> Community will be testing in an upcoming Fedora Test Day.

EFI support in QEMU would make testing this feature possible for lots more folk. If anyone is interested, they should take a look at the code above.
Comment 4 Daniel Berrange 2009-04-06 10:55:42 EDT
Be afraid of the EFI firmware :-)

We looked at this for Xen quite a while back and it was quite a handful to deal with. The build system has a huge level of complexity, building ANT java plugins, then running ANT, in order to run GCC (a GCC 3.x  because the code wouldn't build with 4.x). It didn't work with GCJ at the time, but thankfully OpenJDK should put is in better shape wrt to actually being able to build. Upstream talked about ripping out their build system & using python instead, but that doesn't seem to have happened yet. 

The other unpleasant bit was that to get a working BIOS required building from specific Mercurial changeset, combined with a checkout of code from a separate SVN repository at another specific changeset. There were no formal released tar.gz available :-(

These are all solvable problems, just don't expect it to be a small piece of work to drop in an EFI BIOS.
Comment 5 Fedora Admin XMLRPC Client 2009-05-07 08:12:14 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 6 Fedora Admin XMLRPC Client 2009-05-07 08:13:11 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 7 Fedora Admin XMLRPC Client 2009-05-07 08:13:38 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 8 Fedora Admin XMLRPC Client 2009-05-07 13:58:02 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 9 Peter Jones 2009-05-20 11:20:46 EDT
> We looked at this for Xen quite a while back and it was quite a handful to deal
> with. The build system has a huge level of complexity, building ANT java
> plugins, then running ANT, in order to run GCC (a GCC 3.x  because the code
> wouldn't build with 4.x). It didn't work with GCJ at the time, but thankfully
> OpenJDK should put is in better shape wrt to actually being able to build.
> Upstream talked about ripping out their build system & using python instead,
> but that doesn't seem to have happened yet.

FWIW, this whole paragraph is largely obsoleted with EDK2.
Comment 10 Peter Jones 2009-05-20 11:34:23 EDT
FWIW, I'm tracking progress on this at https://fedoraproject.org/wiki/User:Pjones/KvmEFI
Comment 11 Daniel Berrange 2009-05-20 11:35:42 EDT
Err, it was EDK2 that was used by the Xen EFI BIOS when I investigated all this.  Perhaps they have since re-written the EDK2 build system to have smaller quantities of crack, but the README in the efi-vfirmware.hg repository still says you need to use the long since obsolete  gcc 3.4 and not gcc 4.x and doesn't appear to have any less painful depedancies.
Comment 12 Bug Zapper 2009-06-09 06:18:20 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Fedora Admin XMLRPC Client 2010-03-09 11:53:16 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 14 Fedora Admin XMLRPC Client 2010-03-09 12:17:12 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 15 Bug Zapper 2010-04-27 08:32:37 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 16 Bug Zapper 2011-06-02 14:20:38 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 17 Fabian Deutsch 2011-11-05 11:23:29 EDT
Any news on or interest in this?
I've tested the OVMF firmware with some recent qemu, the EFI bios et's loaded, but fedora fails to start (ubuntu does), the actual steps I did can be found here:
http://dummdida.blogspot.com/2011/09/efi-kvm.html
Comment 18 Laszlo Ersek 2011-12-15 09:22:57 EST
Hello Fabian,

(In reply to comment #17)

> I've tested the OVMF firmware with some recent qemu, the EFI bios et's loaded,
> but fedora fails to start (ubuntu does), the actual steps I did can be found
> here:
> http://dummdida.blogspot.com/2011/09/efi-kvm.html

Do you specifically care about fc15? Because in a later post of yours <http://dummdida.blogspot.com/2011/10/update-on-efi-and-fedora-16-live-images.html> you mention that fc16 should work okay. I'll try to install fc16 as a qemu/kvm guest sometime.

Thanks.
Comment 19 Fabian Deutsch 2011-12-15 09:33:16 EST
i Laszlo,

(In reply to comment #18)
> (In reply to comment #17)
> 
> > I've tested the OVMF firmware with some recent qemu, the EFI bios et's loaded,
> > but fedora fails to start (ubuntu does), the actual steps I did can be found
> > here:
> > http://dummdida.blogspot.com/2011/09/efi-kvm.html
> 
> Do you specifically care about fc15? Because in a later post of yours
> <http://dummdida.blogspot.com/2011/10/update-on-efi-and-fedora-16-live-images.html>
> you mention that fc16 should work okay. I'll try to install fc16 as a qemu/kvm
> guest sometime.

I just noted that the RC of Fedora 16 got EFI support again, but this had nothing todo with running Fedora under EFI+KVM/QEMU.

I tried running Fedora 16 with an EFI-BIOS under QEMU, but this also didn't work completely.
Grub get's loaded but then there is no more progress.

Greetings
Comment 20 Fedora Admin XMLRPC Client 2012-03-15 13:55:01 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 21 Cole Robinson 2012-05-28 20:52:59 EDT
F15 is end of life in a month, moving this to F17.

So what exactly does implementing this entail? Sounds like there is OVMF firmware that works with qemu + ubuntu at least, without qemu modification. So this request is to

- Package said firmware
- Find a way to make fedora work with said firmware
- Some qemu packaging bits to tie it together.

Does that sound right? If so, limping this bug along for 3.5 years doesn't make much sense IMO.
Comment 23 Cole Robinson 2012-05-29 18:34:22 EDT
For fedora it sounds like the primary piece here is just packaging OVMF.

If any interested community member or redhatter wants to give that a whirl, I'll happily review the package and make the qemu packaging changes, but honestly the presence of this bug is unlikely to have an impact on when this feature is enabled in fedora, since the work involved is largely outside the scope of qemu. And there's already various wiki pages on the web about using qemu and efi, so the info here isn't anything new.

Closing CANTFIX, but if anyone submits an OVMF package review, please file a new qemu bug so we can get things properly integrated.

Note You need to log in before you can comment on or make changes to this bug.